/*
 * ObjectCreator.java
 *
 * Created on 12. Mrz 2004, 13:10
 */

package de.hr.xred.hronline.scriptinvoker;
import luajava.*;
/**
 * Object Creator for Lua
 * @author  TPRAXL
 */
public class ObjectCreator extends luajava.JavaFunction {
  protected luajava.LuaState state;
  /** Creates a new instance of ObjectCreator and registers the LuaFunction "createJavaObject"
   *  This is needed for the documentation of the scripts.
   *@param LuaState the Instance of Lua
   */
  public ObjectCreator(luajava.LuaState l){
    super(l);
    try{
      this.register("createJavaObject");
    }
    catch(Exception e){
       System.out.println("Fehler beim Registrieren des Object-Creators: "+e.getMessage());
    }
    this.state = l;
  }
  /**
   * This method is called, when Lua executes the registered function.
   * Please note that you may restrict the creation of Objects in this function.
   * 
   */
  public int foo() {
    try{
      String desiredObjectClass = this.getParam(2).toString();
      if(desiredObjectClass !=null){
        //At this point, we are able to limit the scriptrights.
        //If we dont want to create an object of de.blueorange.xred.-package,
        //we could write: 
        //if(desiredObjectClass.startsWith("de.blueorange.xred"))
        //  pushNil
        //else
        Class fooClass  = Class.forName(desiredObjectClass);
        Object object = fooClass.newInstance();
        this.state.pushJavaObject( object);
      }
    }
    catch(Exception e){
      System.out.println("Fehler beim Erstellen eines Java-Objektes: "+e.getMessage());
      this.state.pushNil();
    }
    return 1;
  }
  
}
